// Connect.h : Declaration of the CConnect

#pragma once
#include "resource.h"       // main symbols

// CConnect
class ATL_NO_VTABLE CConnect : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConnect, &CLSID_Connect>,
		public IDispatchImpl<EnvDTE::IDTCommandTarget, &EnvDTE::IID_IDTCommandTarget, &EnvDTE::LIBID_EnvDTE, 7, 0>,
	public IDispatchImpl<AddInDesignerObjects::_IDTExtensibility2, &AddInDesignerObjects::IID__IDTExtensibility2, &AddInDesignerObjects::LIBID_AddInDesignerObjects, 1, 0>
{
public:
	CConnect() :
		m_ourBuild(false)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)
DECLARE_NOT_AGGREGATABLE(CConnect)


BEGIN_COM_MAP(CConnect)
	COM_INTERFACE_ENTRY(AddInDesignerObjects::IDTExtensibility2)
	COM_INTERFACE_ENTRY(EnvDTE::IDTCommandTarget)
	COM_INTERFACE_ENTRY2(IDispatch, AddInDesignerObjects::IDTExtensibility2)
END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{
	}

public:
	//IDTExtensibility2 implementation:
	STDMETHOD(OnConnection)(IDispatch * Application, AddInDesignerObjects::ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom);
	STDMETHOD(OnDisconnection)(AddInDesignerObjects::ext_DisconnectMode RemoveMode, SAFEARRAY **custom );
	STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom );
	STDMETHOD(OnStartupComplete)(SAFEARRAY **custom );
	STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom );
	
	//IDTCommandTarget implementation:
	STDMETHOD(QueryStatus)(BSTR CmdName, EnvDTE::vsCommandStatusTextWanted NeededText, EnvDTE::vsCommandStatus *StatusOption, VARIANT *CommandText);
	STDMETHOD(Exec)(BSTR CmdName, EnvDTE::vsCommandExecOption ExecuteOption, VARIANT *VariantIn, VARIANT *VariantOut, VARIANT_BOOL *Handled);

	CComPtr<EnvDTE::_DTE> m_pDTE;
	CComPtr<EnvDTE::AddIn> m_pAddInInstance;
	
	void SetKeyBinding(bool justText, const CStringW& command, const CStringW& binding);
	CComPtr<EnvDTE::OutputWindowPane> GetOutputWindowPane(const CString& name, bool show = true);
	bool BuildActiveProject();
	void DebugActiveProject();
	bool RecurseDependencies(CComPtr<EnvDTE::Project>& pProject);

	void OnBuildDone();
    HRESULT OnBuildProjConfigBegin(BSTR Project, BSTR ProjectConfig, BSTR Platform, BSTR SolutionConfig);
	HRESULT OnBuildProjConfigDone(BSTR Project, BSTR ProjectConfig, BSTR Platform, BSTR SolutionConfig, VARIANT_BOOL Success);

	void ParseVCProjFSBFile(const CString& vcprojFSB);

	CComPtr<EnvDTE::OutputWindowPane> m_owPane;
	CComPtr<EnvDTE::SolutionBuild> m_pSolutionBuild;
	CComPtr<EnvDTE::SolutionConfiguration> m_pSolutionConfiguration;
	CComPtr<EnvDTE::SolutionContexts> m_pSolutionContexts;
	CComPtr<EnvDTE::BuildDependencies> m_pBuildDependencies;

	CString m_solutionName;
	CString m_projectName;
	CString m_solutionConfigurationName;

	typedef CAtlMap<CComBSTR, bool> ProjectsMap;
	ProjectsMap m_projectsProcessed;

	typedef CComPtr<VCProjectEngineLibrary70::VCConfiguration> VCConfiguration70;
	typedef CComPtr<VCProjectEngineLibrary71::VCConfiguration> VCConfiguration71;

	typedef CAtlList<VCConfiguration70> ProjectsList70;
	ProjectsList70 m_projectCompileOrder70;
	typedef CAtlList<VCConfiguration71> ProjectsList71;
	ProjectsList71 m_projectCompileOrder71;

	CComQIPtr<VCProjectEngineLibrary70::VCPlatform> m_pPlatform70;
	CComQIPtr<VCProjectEngineLibrary71::VCPlatform> m_pPlatform71;

	bool m_vc70;

	bool m_ourBuild;
	int m_numProjectsChecked;
	int m_totalProjects;

	CString m_objFiles;
	CAtlArray<CString> m_cppExts;
//	CString m_pathEnv;
//	CString m_copyLocation;

	bool m_doIncrementalLink;
};

OBJECT_ENTRY_AUTO(__uuidof(Connect), CConnect)
